libzypp: zypp::Pattern Class Reference

libzypp 17.25.10

Classes | Public Types | Public Member Functions | List of all members
zypp::Pattern Class Reference

Pattern interface. More...

`#include <Pattern.h>`

Inheritance diagram for zypp::Pattern:
[legend]

## Classes
struct | ContentsSet

## Public Types
typedef Pattern | Self
typedef ResTraits< Self > | TraitsType
typedef TraitsType::PtrType | Ptr
typedef TraitsType::constPtrType | constPtr
typedef sat::ArrayAttr< IdString, IdString > | NameList
typedef sat::SolvableSet | Contents
Public Types inherited from zypp::ResObject
typedef ResObject | Self
typedef ResTraits< Self > | TraitsType
typedef TraitsType::PtrType | Ptr
typedef TraitsType::constPtrType | constPtr
Public Types inherited from zypp::Resolvable
typedef Resolvable | Self
typedef ResTraits< Self > | TraitsType
typedef TraitsType::KindType | Kind
typedef TraitsType::PtrType | Ptr
typedef TraitsType::constPtrType | constPtr

## Public Member Functions
bool | isDefault () const
bool | userVisible () const
std::string | category (const Locale &lang_r=Locale()) const
Pathname | icon () const
Pathname | script () const
std::string | order () const
Public Member Functions inherited from zypp::ResObject
template<class TRes >
ResTraits< TRes >::constPtrType | asKind () const
| Convert `this` into a Ptr of a certain Kind. More...
template<class TRes >
ResTraits< TRes >::PtrType | asKind ()
Vendor | vendor () const
| Vendor. More...
Public Member Functions inherited from zypp::Resolvable
| operator sat::Solvable () const
| This is a sat::SolvableType. More...
PoolItem | poolItem () const
| Access the corresponding PoolItem. More...
Public Member Functions inherited from zypp::sat::SolvableType< Resolvable >
Solvable | satSolvable () const
| Return the corresponding sat::Solvable. More...
| operator bool () const
IdString | ident () const
ResKind | kind () const
bool | isKind (const ResKind &kind_r) const
bool | isKind () const
bool | isKind (TIterator begin, TIterator end) const
std::string | name () const
Edition | edition () const
Arch | arch () const
IdString | vendor () const
Repository | repository () const
RepoInfo | repoInfo () const
bool | isSystem () const
bool | onSystemByUser () const
bool | onSystemByAuto () const
bool | identIsAutoInstalled () const
bool | multiversionInstall () const
bool | isNeedreboot () const
bool | isRetracted () const
bool | isPtf () const
Date | buildtime () const
Date | installtime () const
std::string | asString () const
std::string | asUserString () const
bool | identical (const Solvable &rhs) const
bool | identical (const SolvableType< RDerived > &rhs) const
bool | sameNVRA (const Solvable &rhs) const
bool | sameNVRA (const SolvableType< RDerived > &rhs) const
Capabilities | provides () const
Capabilities | conflicts () const
Capabilities | obsoletes () const
Capabilities | recommends () const
Capabilities | suggests () const
Capabilities | enhances () const
Capabilities | supplements () const
Capabilities | prerequires () const
Capabilities | dep (Dep which_r) const
Capabilities | operator[] (Dep which_r) const
CapabilitySet | providesNamespace (const std::string &namespace_r) const
CapabilitySet | valuesOfNamespace (const std::string &namespace_r) const
bool | supportsLocales () const
bool | supportsLocale (const Locale &locale_r) const
bool | supportsLocale (const LocaleSet &locales_r) const
bool | supportsRequestedLocales () const
LocaleSet | getSupportedLocales () const
CpeId | cpeId () const
unsigned | mediaNr () const
ByteCount | installSize () const
ByteCount | downloadSize () const
std::string | distribution () const
std::string | summary (const Locale &lang_r=Locale()) const
std::string | description (const Locale &lang_r=Locale()) const
std::string | insnotify (const Locale &lang_r=Locale()) const
std::string | delnotify (const Locale &lang_r=Locale()) const
std::string | licenseToConfirm (const Locale &lang_r=Locale()) const
bool | needToAcceptLicense () const
std::string | lookupStrAttribute (const SolvAttr &attr) const
std::string | lookupStrAttribute (const SolvAttr &attr, const Locale &lang_r) const
bool | lookupBoolAttribute (const SolvAttr &attr) const
detail::IdType | lookupIdAttribute (const SolvAttr &attr) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr, unsigned long long notfound_r) const
CheckSum | lookupCheckSumAttribute (const SolvAttr &attr) const
OnMediaLocation | lookupLocation () const
Solvable::IdType | id () const
Public Member Functions inherited from zypp::base::ReferenceCounted
| ReferenceCounted ()
| Default ctor. More...
| ReferenceCounted (const ReferenceCounted &rhs)
| Copy ctor. More...
virtual | ~ReferenceCounted ()
| Dtor. More...
ReferenceCounted & | operator= (const ReferenceCounted &)
| Assignment. More...
unsigned | refCount () const
| Return reference counter value. More...
void | ref () const
| Add a reference. More...
void | unref () const
| Release a reference. More...

## Auto pattens (libyzpp-14)
Patterns are no longer defined by separate metadate files, but via special dependencies provided by a corresponding patterns- package. The pattern itself requires only it's patterns- package, the package contains all further dependencies. This way pattens are no longer pseudo installed objects with a computed status, but installed, iff the corresponding patterns- package is installed.
bool | isAutoPattern () const
| This patterns is auto-defined by a patterns- package. More...
sat::Solvable | autoPackage () const
| The corresponding patterns- package if isAutoPattern. More...
NameList | includes () const
| Ui hint: included patterns. More...
NameList | extends () const
| Ui hint: patterns this one extends. More...
Contents | core () const
| Ui hint: Required Packages. More...
Contents | depends (bool includeSuggests_r=true) const
| Ui hint: Dependent packages. More...
Contents | dependsNoSuggests () const
Contents | contents (bool includeSuggests_r=true) const
| The collection of packages associated with this pattern. More...
Contents | contentsNoSuggests () const
void | contentsSet (ContentsSet &collect_r, bool recursively_r=false) const
| Dependency based content set (does not evaluate includes/extends relation). More...
void | fullContentsSet (ContentsSet &collect_r) const
Ptr | make (const sat::Solvable &solvable_r)
| Directly create a certain kind of ResObject from sat::Solvable. More...
| Pattern (const sat::Solvable &solvable_r)
| Ctor. More...
virtual | ~Pattern ()
| Dtor. More...

## Additional Inherited Members
Static Public Member Functions inherited from zypp::base::ReferenceCounted
static void | add_ref (const ReferenceCounted *ptr_r)
| Called by zypp::intrusive_ptr to add a reference. More...
static void | release (const ReferenceCounted *ptr_r)
| Called by zypp::intrusive_ptr to add a reference. More...
Public Attributes inherited from zypp::sat::SolvableType< Resolvable >
Capabilities | const
Protected Member Functions inherited from zypp::ResObject
| ResObject (const sat::Solvable &solvable_r)
| Ctor. More...
virtual | ~ResObject ()
| Dtor. More...
virtual std::ostream & | dumpOn (std::ostream &str) const
| Helper for stream output. More...
| operator sat::Solvable () const
| This is a sat::SolvableType (allow implicit conversion in derived classes). More...
Protected Member Functions inherited from zypp::Resolvable
| Resolvable (const sat::Solvable &solvable_r)
| Ctor. More...
virtual | ~Resolvable ()
| Dtor. More...
Protected Member Functions inherited from zypp::sat::SolvableType< Resolvable >
| SolvableType ()
| SolvableType (const SolvableType &)
| SolvableType (SolvableType &&)
void | operator= (const SolvableType &)
void | operator= (SolvableType &&)
| ~SolvableType ()
Protected Member Functions inherited from zypp::base::ReferenceCounted
virtual void | ref_to (unsigned) const
| Trigger derived classes after refCount was increased. More...
virtual void | unref_to (unsigned) const
| Trigger derived classes after refCount was decreased. More...
Related Functions inherited from zypp::ResObject
template<class TRes >
ResTraits< TRes >::PtrType | asKind (const ResObject::Ptr &p)
| Convert ResObject::Ptr into Ptr of a certain Kind. More...
Related Functions inherited from zypp::Resolvable
std::ostream & | operator<< (std::ostream &str, const Resolvable &obj)
| Stream output. More...
std::ostream & | dumpOn (std::ostream &str, const Resolvable &obj)
| More verbose stream output including dependencies. More...
template<class TRes >
bool | isKind (const Resolvable::constPtr &p)
| Test whether a Resolvable::Ptr is of a certain Kind. More...
template<class TRes >
ResTraits< TRes >::PtrType | asKind (const Resolvable::Ptr &p)
| Convert Resolvable::Ptr into Ptr of a certain Kind. More...
int | compareByN (const Resolvable::constPtr &lhs, const Resolvable::constPtr &rhs)
| Compare Resolvable::constPtr according to kind and name. More...
int | compareByNVR (const Resolvable::constPtr &lhs, const Resolvable::constPtr &rhs)
| Compare according to kind, name and edition. More...
int | compareByNVRA (const Resolvable::constPtr &lhs, const Resolvable::constPtr &rhs)
| Compare Resolvable::constPtr according to kind, name, edition and arch. More...
Related Functions inherited from zypp::sat::SolvableType< Resolvable >
bool | isKind (const SolvableType< Resolvable > &solvable_r)
| Test whether the Solvable is of a certain ResKind. More...
bool | identical (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Test for same content. More...
bool | sameNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Test for same name version release and arch. More...
std::ostream & | operator<< (std::ostream &str, const SolvableType< Resolvable > &obj)
| Stream output. More...
std::ostream & | dumpOn (std::ostream &str, const SolvableType< Resolvable > &obj)
| More verbose stream output including dependencies. More...
bool | operator== (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Equal. More...
bool | operator!= (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| NotEqual. More...
bool | operator< (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Less. More...
int | compareByN (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind and name. More...
int | compareByNVR (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind, name and edition. More...
int | compareByNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| Compare according to kind, name, edition and arch. More...
Related Functions inherited from zypp::base::ReferenceCounted
void | intrusive_ptr_add_ref (const ReferenceCounted *ptr_r)
| intrusive_ptr hook to add_ref. More...
void | intrusive_ptr_release (const ReferenceCounted *ptr_r)
| intrusive_ptr hook to release. More...
std::ostream & | operator<< (std::ostream &str, const ReferenceCounted &obj)
| Stream output. More...

## Detailed Description

Pattern interface.

Definition at line 31 of file Pattern.h.

## Member Typedef Documentation

## ◆ Self

typedef Pattern zypp::Pattern::Self

Definition at line 34 of file Pattern.h.

## ◆ TraitsType

typedef ResTraits<Self> zypp::Pattern::TraitsType

Definition at line 35 of file Pattern.h.

## ◆ Ptr

typedef TraitsType::PtrType zypp::Pattern::Ptr

Definition at line 36 of file Pattern.h.

## ◆ constPtr

typedef TraitsType::constPtrType zypp::Pattern::constPtr

Definition at line 37 of file Pattern.h.

## ◆ NameList

typedef sat::ArrayAttr<IdString,IdString> zypp::Pattern::NameList

Definition at line 40 of file Pattern.h.

## ◆ Contents

typedef sat::SolvableSet zypp::Pattern::Contents

Definition at line 41 of file Pattern.h.

## Constructor & Destructor Documentation

## ◆ Pattern()

zypp::Pattern::Pattern | ( | const sat::Solvable & | solvable_r | ) |
| protected

Ctor.

Definition at line 173 of file Pattern.cc.

## ◆ ~Pattern()

zypp::Pattern::~Pattern | ( |  | ) |
| protectedvirtual

Dtor.

Definition at line 177 of file Pattern.cc.

## Member Function Documentation

## ◆ isDefault()

bool zypp::Pattern::isDefault | ( |  | ) | const

Definition at line 180 of file Pattern.cc.

## ◆ userVisible()

bool zypp::Pattern::userVisible | ( |  | ) | const

Definition at line 183 of file Pattern.cc.

## ◆ category()

std::string zypp::Pattern::category | ( | const Locale & | lang_r = `Locale()` | ) | const

Definition at line 192 of file Pattern.cc.

## ◆ icon()

Pathname zypp::Pattern::icon | ( |  | ) | const

Definition at line 195 of file Pattern.cc.

## ◆ script()

Pathname zypp::Pattern::script | ( |  | ) | const

Definition at line 198 of file Pattern.cc.

## ◆ order()

std::string zypp::Pattern::order | ( |  | ) | const

Definition at line 201 of file Pattern.cc.

## ◆ isAutoPattern()

bool zypp::Pattern::isAutoPattern | ( |  | ) | const

This patterns is auto-defined by a patterns- package.

Definition at line 204 of file Pattern.cc.

## ◆ autoPackage()

sat::Solvable zypp::Pattern::autoPackage | ( |  | ) | const

The corresponding patterns- package if isAutoPattern.

Definition at line 207 of file Pattern.cc.

## ◆ includes()

Pattern::NameList zypp::Pattern::includes | ( |  | ) | const

Ui hint: included patterns.

Definition at line 220 of file Pattern.cc.

## ◆ extends()

Pattern::NameList zypp::Pattern::extends | ( |  | ) | const

Ui hint: patterns this one extends.

Definition at line 223 of file Pattern.cc.

## ◆ core()

Pattern::Contents zypp::Pattern::core | ( |  | ) | const

Ui hint: Required Packages.

Definition at line 240 of file Pattern.cc.

## ◆ depends()

Pattern::Contents zypp::Pattern::depends | ( | bool | includeSuggests_r = `true` | ) | const

Ui hint: Dependent packages.

This also includes recommended and suggested (optionally exclude) packages.

Definition at line 258 of file Pattern.cc.

## ◆ dependsNoSuggests()

Contents zypp::Pattern::dependsNoSuggests | ( |  | ) | const
| inline

Definition at line 88 of file Pattern.h.

## ◆ contents()

Pattern::Contents zypp::Pattern::contents | ( | bool | includeSuggests_r = `true` | ) | const

The collection of packages associated with this pattern.

This also evaluates the patterns includes/extends relation. Optionally exclude `SUGGESTED` packages.

Definition at line 284 of file Pattern.cc.

## ◆ contentsNoSuggests()

Contents zypp::Pattern::contentsNoSuggests | ( |  | ) | const
| inline

Definition at line 97 of file Pattern.h.

## ◆ contentsSet()

Convenience for recursively expanded zypp::Pattern::contentsSet | ( | ContentsSet & | collect_r,
|  | bool | recursively_r = `false`
| ) |  | const

Dependency based content set (does not evaluate includes/extends relation).

If recursively_r, required and recommended patterns are recursively expanded.

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 332 of file Pattern.cc.

## ◆ fullContentsSet()

void zypp::Pattern::fullContentsSet | ( | ContentsSet & | collect_r | ) | const
| inline

Definition at line 113 of file Pattern.h.

## Friends And Related Function Documentation

## ◆ make

Ptr make | ( | const sat::Solvable & | solvable_r | ) |
| friend

Directly create a certain kind of ResObject from sat::Solvable.

If the sat::Solvables kind is not appropriate, a NULL pointer is returned.

sat::Solvable s;
ResObject::Ptr p( makeResObject( s ) );
ResObject::Ptr q( make<ResObject>( s ) );
Package::Ptr pkg( make<Package>( s ) );
zypp::Package::Ptr
TraitsType::PtrType Ptr
Definition: Package.h:37
zypp::ResObject::makeResObject
friend ResObject::Ptr makeResObject(const sat::Solvable &solvable_r)
Create ResObject from sat::Solvable.
Definition: ResObject.cc:43
zypp::ResObject::Ptr
TraitsType::PtrType Ptr
Definition: ResObject.h:42
zypp::make< ResObject >
ResObject::Ptr make< ResObject >(const sat::Solvable &solvable_r)
Definition: ResObject.h:122

Todo:
  make<> was a poor choice (AFAIR because gcc had some trouble with asKind<>(sat::Solvable)). Remove it in favour of asKind<>(sat::Solvable)

Definition at line 118 of file ResObject.h.

The documentation for this class was generated from the following files:

- zypp/Pattern.h
- zypp/Pattern.cc